package epsilonStandalone;

import MMDNI3.Common;
import MMDNI3.CommunicatingApplication;
import MMDNI3.ConstantDoubleVariable;
import MMDNI3.DNIUnit;
import MMDNI3.Dependency;
import MMDNI3.Direction;
import MMDNI3.End;
import MMDNI3.Flow;
import MMDNI3.FlowRoute;
import MMDNI3.IType;
import MMDNI3.Intermediate;
import MMDNI3.IntermediatePerformance;
import MMDNI3.Link;
import MMDNI3.MMDNI3Package;
import MMDNI3.NamedElement;
import MMDNI3.NetworkConfiguration;
import MMDNI3.NetworkInfrastructure;
import MMDNI3.NetworkInterface;
import MMDNI3.NetworkStructure;
import MMDNI3.NetworkTraffic;
import MMDNI3.Node;
import MMDNI3.PerformanceLink;
import MMDNI3.PerformanceNetworkInterface;
import MMDNI3.RoutesRepository;
import OMNET.Channel;
import OMNET.ChannelConnectionItem;
import OMNET.Connection;
import OMNET.Connections;
import OMNET.LocalType;
import OMNET.ModuleParam;
import OMNET.NedFile;
import OMNET.Network;
import OMNET.OMNETFactory;
import OMNET.OMNETPackage;
import OMNET.OmnetppIniFile;
import OMNET.OmnetppIniGroup;
import OMNET.OmnetppIniLine;
import OMNET.PortID;
import OMNET.RoutingXmlFile;
import OMNET.StringParameter;
import OMNET.SubModule;
import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import java.io.FileOutputStream;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class OmnetGenericTransformation {
  private final static String NAME = "dni3toomnet";
  
  private final static OMNETFactory fac = OMNETFactory.eINSTANCE;
  
  private final static OMNETPackage omn = OMNETPackage.eINSTANCE;
  
  public static void main(final String[] args) {
    String fname = "src/epsilonStandalone/models/scenario0B_1.MMDNI3";
    int _length = args.length;
    boolean _lessThan = (_length < 1);
    if (_lessThan) {
      InputOutput.<String>println((OmnetGenericTransformation.NAME + " expects a filename as its first input, see --help for more information. Continuing with default file minimal.MMDNI3"));
    } else {
      String _get = args[0];
      boolean _equals = _get.equals("--help");
      if (_equals) {
        InputOutput.<String>print("TODO Help");
        return;
      } else {
        String _get_1 = args[0];
        fname = _get_1;
      }
    }
    final URI MMDNI3Uri = URI.createFileURI(fname);
    final URI omnetUri = URI.createFileURI("src/epsilonStandalone/models/omnet_base.omnetmodel");
    final ResourceSetImpl resourceSet = new ResourceSetImpl();
    final EPackage.Registry packageRegistry = resourceSet.getPackageRegistry();
    packageRegistry.put(OMNETPackage.eNS_URI, OMNETPackage.eINSTANCE);
    packageRegistry.put(MMDNI3Package.eNS_URI, MMDNI3Package.eINSTANCE);
    final Map<String, Object> extensionFactoryMap = Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap();
    XMIResourceFactoryImpl _xMIResourceFactoryImpl = new XMIResourceFactoryImpl();
    extensionFactoryMap.put("MMDNI3", _xMIResourceFactoryImpl);
    XMIResourceFactoryImpl _xMIResourceFactoryImpl_1 = new XMIResourceFactoryImpl();
    extensionFactoryMap.put("omnetmodel", _xMIResourceFactoryImpl_1);
    final Resource dniResource = resourceSet.getResource(MMDNI3Uri, true);
    final Resource omnetResource = resourceSet.getResource(omnetUri, true);
    OmnetGenericTransformation.do_transformation(dniResource, omnetResource);
    XMIResourceImpl _xMIResourceImpl = new XMIResourceImpl();
    final Procedure1<XMIResourceImpl> _function = (XMIResourceImpl it) -> {
      try {
        EList<EObject> _contents = it.getContents();
        EList<EObject> _contents_1 = omnetResource.getContents();
        EObject _get_2 = _contents_1.get(0);
        _contents.add(_get_2);
        FileOutputStream _fileOutputStream = new FileOutputStream("src/epsilonStandalone/models/output_omnet.xmi");
        it.save(_fileOutputStream, null);
      } catch (Throwable _e) {
        throw Exceptions.sneakyThrow(_e);
      }
    };
    ObjectExtensions.<XMIResourceImpl>operator_doubleArrow(_xMIResourceImpl, _function);
  }
  
  private static String do_transformation(final Resource dniResource, final Resource omnetResource) {
    String _xblockexpression = null;
    {
      EList<EObject> _contents = dniResource.getContents();
      EObject _get = _contents.get(0);
      final NetworkInfrastructure dniModel = ((NetworkInfrastructure) _get);
      EList<EObject> _contents_1 = omnetResource.getContents();
      EObject _get_1 = _contents_1.get(0);
      final NedFile omnetModel = ((NedFile) _get_1);
      InputOutput.<String>println("== Starting transformation ==");
      final NetworkInfrastructure dni = dniModel;
      final NedFile ned = omnetModel;
      final OmnetppIniFile ini = omnetModel.getConfig();
      OmnetppIniFile _config = omnetModel.getConfig();
      final RoutingXmlFile routingxml = _config.getRoutingconf();
      String _dataCenterName = dni.getDataCenterName();
      String _plus = ("example_" + _dataCenterName);
      String _plus_1 = (_plus + ".xml");
      routingxml.setFilename(_plus_1);
      final Network netWork = OmnetGenericTransformation.fac.createNetwork();
      netWork.setName("Submodules");
      OmnetGenericTransformation.createSimController(netWork);
      final LocalType global = OmnetGenericTransformation.fac.createLocalType();
      global.setName("GlobalVars");
      final OmnetppIniGroup iniGroup = OmnetGenericTransformation.fac.createOmnetppIniGroup();
      iniGroup.setName("General");
      TreeIterator<EObject> _allContents = dniResource.getAllContents();
      Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
      for (final EObject e : _iterable) {
        InputOutput.<EObject>println(e);
      }
      TreeIterator<EObject> _allContents_1 = dniResource.getAllContents();
      Iterable<EObject> _iterable_1 = IteratorExtensions.<EObject>toIterable(_allContents_1);
      Iterable<NamedElement> _filter = Iterables.<NamedElement>filter(_iterable_1, NamedElement.class);
      for (final NamedElement e_1 : _filter) {
        String _name = e_1.getName();
        InputOutput.<String>println(_name);
      }
      NetworkStructure _structure = dni.getStructure();
      EList<Node> _nodes = _structure.getNodes();
      final Function1<Node, Boolean> _function = (Node it) -> {
        IType _sdntype = it.getSdntype();
        return Boolean.valueOf((_sdntype instanceof Common));
      };
      Iterable<Node> _filter_1 = IterableExtensions.<Node>filter(_nodes, _function);
      final Function1<Node, Node> _function_1 = (Node it) -> {
        return ((Node) it);
      };
      final Iterable<Node> dniCommonNodes = IterableExtensions.<Node, Node>map(_filter_1, _function_1);
      for (final Node n : dniCommonNodes) {
        OmnetGenericTransformation.parseNodes(netWork, iniGroup, n);
      }
      NetworkTraffic _traffic = dni.getTraffic();
      EList<CommunicatingApplication> _software = _traffic.getSoftware();
      final Function1<CommunicatingApplication, CommunicatingApplication> _function_2 = (CommunicatingApplication it) -> {
        return ((CommunicatingApplication) it);
      };
      final List<CommunicatingApplication> CommunicatingApplications = ListExtensions.<CommunicatingApplication, CommunicatingApplication>map(_software, _function_2);
      for (final CommunicatingApplication n_1 : CommunicatingApplications) {
        OmnetGenericTransformation.parseCommunicatingApp(netWork, iniGroup, n_1);
      }
      NetworkTraffic _traffic_1 = dni.getTraffic();
      EList<Flow> _flows = _traffic_1.getFlows();
      final Function1<Flow, Flow> _function_3 = (Flow it) -> {
        return ((Flow) it);
      };
      final List<Flow> flows = ListExtensions.<Flow, Flow>map(_flows, _function_3);
      for (final Flow n_2 : flows) {
        OmnetGenericTransformation.parseFlow(netWork, n_2);
      }
      final Connections connections = OmnetGenericTransformation.fac.createConnections();
      NetworkStructure _structure_1 = dni.getStructure();
      EList<Link> _links = _structure_1.getLinks();
      final Function1<Link, Link> _function_4 = (Link it) -> {
        return ((Link) it);
      };
      final List<Link> links = ListExtensions.<Link, Link>map(_links, _function_4);
      for (final Link l : links) {
        {
          OmnetGenericTransformation.parseLinks(netWork, connections, l);
          netWork.setConnections(connections);
        }
      }
      NetworkConfiguration _configuration = dni.getConfiguration();
      RoutesRepository _routes = _configuration.getRoutes();
      final EList<Direction> directions = _routes.getDirections();
      for (final Direction d : directions) {
        OmnetGenericTransformation.parseDirections(iniGroup, d);
      }
      NetworkConfiguration _configuration_1 = dni.getConfiguration();
      RoutesRepository _routes_1 = _configuration_1.getRoutes();
      final EList<FlowRoute> routes = _routes_1.getFlowRoutes();
      for (final FlowRoute r : routes) {
        OmnetGenericTransformation.parseFlowIni(iniGroup, r);
      }
      EList<LocalType> _definitions = ned.getDefinitions();
      _definitions.add(((LocalType) global));
      EList<LocalType> _definitions_1 = ned.getDefinitions();
      _definitions_1.add(((Network) netWork));
      EList<OmnetppIniGroup> _sections = ini.getSections();
      _sections.add(iniGroup);
      _xblockexpression = InputOutput.<String>println("== Transformation finished ==");
    }
    return _xblockexpression;
  }
  
  private static String parseNodes(final Network net, final OmnetppIniGroup inig, final Node n) {
    String _xblockexpression = null;
    {
      final SubModule node = OmnetGenericTransformation.fac.createSubModule();
      String _name = n.getName();
      node.setName(_name);
      EList<NetworkInterface> _interfaces = n.getInterfaces();
      final Function1<NetworkInterface, NetworkInterface> _function = (NetworkInterface it) -> {
        return ((NetworkInterface) it);
      };
      final List<NetworkInterface> dniInterfaces = ListExtensions.<NetworkInterface, NetworkInterface>map(_interfaces, _function);
      for (final NetworkInterface iF : dniInterfaces) {
        {
          final SubModule netIF = OmnetGenericTransformation.fac.createSubModule();
          String _name_1 = iF.getName();
          netIF.setName(_name_1);
          netIF.setType("NetworkInterface");
          EList<SubModule> _submodules = net.getSubmodules();
          _submodules.add(netIF);
          String _name_2 = iF.getName();
          String _plus = (_name_2 + ".mtu");
          PerformanceNetworkInterface _performance = iF.getPerformance();
          int _mTU = _performance.getMTU();
          String _string = Integer.valueOf(_mTU).toString();
          OmnetGenericTransformation.writeIniLine(inig, "General", _plus, _string, "");
          String _name_3 = iF.getName();
          String _plus_1 = (_name_3 + ".isUp");
          PerformanceNetworkInterface _performance_1 = iF.getPerformance();
          boolean _isIsUp = _performance_1.isIsUp();
          String _string_1 = Boolean.valueOf(_isIsUp).toString();
          OmnetGenericTransformation.writeIniLine(inig, "General", _plus_1, _string_1, "");
        }
      }
      Intermediate _intermediate = n.getIntermediate();
      boolean _notEquals = (!Objects.equal(_intermediate, null));
      if (_notEquals) {
        String _name_1 = n.getName();
        String _plus = (_name_1 + ".nativeSwitchingCapacityPPS");
        Intermediate _intermediate_1 = n.getIntermediate();
        IntermediatePerformance _performance = _intermediate_1.getPerformance();
        Dependency _switchingCapacityPPS = _performance.getSwitchingCapacityPPS();
        String _string = _switchingCapacityPPS.toString();
        Intermediate _intermediate_2 = n.getIntermediate();
        IntermediatePerformance _performance_1 = _intermediate_2.getPerformance();
        Dependency _switchingCapacityPPS_1 = _performance_1.getSwitchingCapacityPPS();
        DNIUnit _unit = _switchingCapacityPPS_1.getUnit();
        String _string_1 = _unit.toString();
        OmnetGenericTransformation.writeIniLine(inig, "General", _plus, _string, _string_1);
        String _name_2 = n.getName();
        String _plus_1 = (_name_2 + ".nativeForwardingLatency");
        Intermediate _intermediate_3 = n.getIntermediate();
        IntermediatePerformance _performance_2 = _intermediate_3.getPerformance();
        Dependency _forwardingLatency = _performance_2.getForwardingLatency();
        String _string_2 = _forwardingLatency.toString();
        Intermediate _intermediate_4 = n.getIntermediate();
        IntermediatePerformance _performance_3 = _intermediate_4.getPerformance();
        Dependency _forwardingLatency_1 = _performance_3.getForwardingLatency();
        double _value = ((ConstantDoubleVariable) _forwardingLatency_1).getValue();
        String _string_3 = Double.valueOf(_value).toString();
        OmnetGenericTransformation.writeIniLine(inig, "General", _plus_1, _string_2, _string_3);
        String _name_3 = n.getName();
        String _plus_2 = (_name_3 + ".nativeForwardingBandwithBPS");
        Intermediate _intermediate_5 = n.getIntermediate();
        IntermediatePerformance _performance_4 = _intermediate_5.getPerformance();
        Dependency _forwardingBandwidthBPS = _performance_4.getForwardingBandwidthBPS();
        String _string_4 = _forwardingBandwidthBPS.toString();
        Intermediate _intermediate_6 = n.getIntermediate();
        IntermediatePerformance _performance_5 = _intermediate_6.getPerformance();
        Dependency _forwardingBandwidthBPS_1 = _performance_5.getForwardingBandwidthBPS();
        DNIUnit _unit_1 = _forwardingBandwidthBPS_1.getUnit();
        String _string_5 = _unit_1.toString();
        OmnetGenericTransformation.writeIniLine(inig, "General", _plus_2, _string_4, _string_5);
      }
      node.setType("Node");
      EList<SubModule> _submodules = net.getSubmodules();
      _submodules.add(node);
      String _xifexpression = null;
      IType _sdntype = n.getSdntype();
      boolean _notEquals_1 = (!Objects.equal(_sdntype, null));
      if (_notEquals_1) {
        _xifexpression = InputOutput.<String>println(("error SDN-Application missing parse rules ." + n));
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  private static Object parseCommunicatingApp(final Network net, final OmnetppIniGroup inig, final CommunicatingApplication a) {
    Object _xblockexpression = null;
    {
      final SubModule app = OmnetGenericTransformation.fac.createSubModule();
      String _name = a.getName();
      app.setName(_name);
      app.setType("CommunicatingApplication");
      EList<SubModule> _submodules = net.getSubmodules();
      _submodules.add(app);
      Object _xifexpression = null;
      End _deployedOn = a.getDeployedOn();
      boolean _notEquals = (!Objects.equal(_deployedOn, null));
      if (_notEquals) {
        Object _xblockexpression_1 = null;
        {
          String _name_1 = a.getName();
          String _plus = (_name_1 + ".deployedOnNode");
          End _deployedOn_1 = a.getDeployedOn();
          Node _node = _deployedOn_1.getNode();
          String _name_2 = _node.getName();
          OmnetGenericTransformation.writeIniLine(inig, "General", _plus, _name_2, "");
          _xblockexpression_1 = OmnetGenericTransformation.generateTraffic(a);
        }
        _xifexpression = _xblockexpression_1;
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  private static boolean parseFlow(final Network net, final Flow f) {
    boolean _xblockexpression = false;
    {
      final SubModule dir = OmnetGenericTransformation.fac.createSubModule();
      String _name = f.getName();
      dir.setName(_name);
      dir.setType("Flow");
      EList<SubModule> _submodules = net.getSubmodules();
      _xblockexpression = _submodules.add(dir);
    }
    return _xblockexpression;
  }
  
  private static boolean parseLinks(final Network net, final Connections cons, final Link l) {
    boolean _xblockexpression = false;
    {
      final ChannelConnectionItem con = OmnetGenericTransformation.fac.createChannelConnectionItem();
      final EList<NetworkInterface> interFaces = l.getConnects();
      boolean _notEquals = (!Objects.equal(interFaces, null));
      if (_notEquals) {
        final PortID portL = OmnetGenericTransformation.fac.createPortID();
        NetworkInterface _get = interFaces.get(0);
        String _name = _get.getName();
        String _plus = (_name + ".tx");
        portL.setName(_plus);
        final PortID portR = OmnetGenericTransformation.fac.createPortID();
        NetworkInterface _get_1 = interFaces.get(1);
        String _name_1 = _get_1.getName();
        String _plus_1 = (_name_1 + ".rx");
        portR.setName(_plus_1);
        String _name_2 = l.getName();
        con.setChannelId(_name_2);
        con.setLeftPort(portL);
        con.setRightPort(portR);
        final Channel perf = OmnetGenericTransformation.fac.createChannel();
        perf.setExtends("ned.DatarateChannel");
        String _name_3 = l.getName();
        perf.setName(_name_3);
        final StringParameter value = OmnetGenericTransformation.fac.createStringParameter();
        String _name_4 = l.getName();
        value.setName(_name_4);
        PerformanceLink _performance = l.getPerformance();
        Dependency _maxSupportedBandwidth = _performance.getMaxSupportedBandwidth();
        DNIUnit _unit = _maxSupportedBandwidth.getUnit();
        String _string = _unit.toString();
        value.setUnit(_string);
        PerformanceLink _performance_1 = l.getPerformance();
        Dependency _maxSupportedBandwidth_1 = _performance_1.getMaxSupportedBandwidth();
        String _string_1 = _maxSupportedBandwidth_1.toString();
        value.setValue(_string_1);
        EList<ModuleParam> _parameters = perf.getParameters();
        _parameters.add(value);
        EList<LocalType> _localTypes = net.getLocalTypes();
        _localTypes.add(perf);
      }
      cons.setAllowunconnected(true);
      EList<Connection> _connections = cons.getConnections();
      _xblockexpression = _connections.add(con);
    }
    return _xblockexpression;
  }
  
  private static boolean createSimController(final Network net) {
    boolean _xblockexpression = false;
    {
      final SubModule simCont = OmnetGenericTransformation.fac.createSubModule();
      simCont.setName("SimController");
      simCont.setType("SimulationController");
      EList<SubModule> _submodules = net.getSubmodules();
      _xblockexpression = _submodules.add(simCont);
    }
    return _xblockexpression;
  }
  
  private static boolean writeIniLine(final OmnetppIniGroup ini, final String nodeSelector, final String parameter, final String value, final String prefix) {
    boolean _xblockexpression = false;
    {
      OmnetppIniLine iniLine = OmnetGenericTransformation.fac.createOmnetppIniLine();
      iniLine.setValue(value);
      iniLine.setNodeSelector(nodeSelector);
      iniLine.setParameter(parameter);
      iniLine.setPrefix(prefix);
      EList<OmnetppIniLine> _lines = ini.getLines();
      _xblockexpression = _lines.add(iniLine);
    }
    return _xblockexpression;
  }
  
  private static boolean parseDirections(final OmnetppIniGroup ini, final Direction d) {
    Node _onNode = d.getOnNode();
    String _description = _onNode.getDescription();
    Flow _flow = d.getFlow();
    String _name = _flow.getName();
    String _plus = (_name + " ");
    NetworkInterface _via = d.getVia();
    String _name_1 = _via.getName();
    String _plus_1 = (_plus + _name_1);
    String _plus_2 = (_plus_1 + " ");
    float _probability = d.getProbability();
    String _string = Float.valueOf(_probability).toString();
    String _plus_3 = (_plus_2 + _string);
    String _name_2 = d.getName();
    String _plus_4 = ("name: " + _name_2);
    return OmnetGenericTransformation.writeIniLine(ini, "General", _description, _plus_3, _plus_4);
  }
  
  private static boolean parseFlowIni(final OmnetppIniGroup ini, final FlowRoute r) {
    boolean _xblockexpression = false;
    {
      Flow _flow = r.getFlow();
      String _name = _flow.getName();
      String _plus = (_name + ".SourceSofware");
      NetworkInterface _start = r.getStart();
      Node _node = _start.getNode();
      String _name_1 = _node.getName();
      OmnetGenericTransformation.writeIniLine(ini, "General", _plus, _name_1, "");
      Flow _flow_1 = r.getFlow();
      String _name_2 = _flow_1.getName();
      String _plus_1 = (_name_2 + ".DestinationSofware");
      NetworkInterface _end = r.getEnd();
      Node _node_1 = _end.getNode();
      String _name_3 = _node_1.getName();
      OmnetGenericTransformation.writeIniLine(ini, "General", _plus_1, _name_3, "");
      Flow _flow_2 = r.getFlow();
      String _name_4 = _flow_2.getName();
      String _plus_2 = (_name_4 + ".sendInterval");
      _xblockexpression = OmnetGenericTransformation.writeIniLine(ini, "General", _plus_2, "0", "s");
    }
    return _xblockexpression;
  }
  
  private static Object generateTraffic(final CommunicatingApplication comApp) {
    return null;
  }
}
