package tools.descartes.dni.dnimm3.tools;

import java.io.File;

import org.junit.Assert;
import org.junit.Test;

import tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl;
import tools.descartes.dni.dnimm3ap.tools.DNIAPParser;
import tools.descartes.dni.dnimm3ap.tools.DNIAPUtil;

public class UtilTest {

	@Test
	public void shouldCloneModel() {
		File file = new File("resources-test/scenario0B.dniap");
		AdaptationPointsImpl adaptationPoints1 = DNIAPParser.convertToModel(file);
		AdaptationPointsImpl adaptationPoints2 = DNIAPUtil.cloneModel(adaptationPoints1);
		Assert.assertNotEquals(adaptationPoints1, adaptationPoints2);
		Assert.assertEquals(adaptationPoints1.getNetworkInfrastructure().getStructure().getNodes().size(),
				adaptationPoints2.getNetworkInfrastructure().getStructure().getNodes().size());
		Assert.assertEquals(
				adaptationPoints1.getNetworkInfrastructure().getStructure().getNodes().get(0).getUid_generated(),
				adaptationPoints2.getNetworkInfrastructure().getStructure().getNodes().get(0).getUid_generated());
	}

}
