/**
 */
package tools.descartes.dni.dnimm3.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import tools.descartes.dni.dnimm3.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DNIFactoryImpl extends EFactoryImpl implements DNIFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DNIFactory init() {
		try {
			DNIFactory theDNIFactory = (DNIFactory)EPackage.Registry.INSTANCE.getEFactory(DNIPackage.eNS_URI);
			if (theDNIFactory != null) {
				return theDNIFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new DNIFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case DNIPackage.NETWORK_INFRASTRUCTURE: return createNetworkInfrastructure();
			case DNIPackage.NETWORK_STRUCTURE: return createNetworkStructure();
			case DNIPackage.NODE: return createNode();
			case DNIPackage.END: return createEnd();
			case DNIPackage.INTERMEDIATE: return createIntermediate();
			case DNIPackage.LINK: return createLink();
			case DNIPackage.NETWORK_INTERFACE: return createNetworkInterface();
			case DNIPackage.NETWORK_TRAFFIC: return createNetworkTraffic();
			case DNIPackage.FLOW: return createFlow();
			case DNIPackage.SDN_CONTROL_FLOW: return createSdnControlFlow();
			case DNIPackage.GENERIC_FLOW_TRAFFIC: return createGenericFlowTraffic();
			case DNIPackage.COMMUNICATING_APPLICATION: return createCommunicatingApplication();
			case DNIPackage.TRAFFIC_SOURCE: return createTrafficSource();
			case DNIPackage.NETWORK_CONFIGURATION: return createNetworkConfiguration();
			case DNIPackage.PROTOCOLS_REPOSITORY: return createProtocolsRepository();
			case DNIPackage.PROTOCOL_STACK: return createProtocolStack();
			case DNIPackage.PROTOCOL_LAYER: return createProtocolLayer();
			case DNIPackage.NETWORK_PROTOCOL: return createNetworkProtocol();
			case DNIPackage.ROUTES_REPOSITORY: return createRoutesRepository();
			case DNIPackage.DIRECTION: return createDirection();
			case DNIPackage.FLOW_ROUTE: return createFlowRoute();
			case DNIPackage.ROUTE: return createRoute();
			case DNIPackage.HOP: return createHop();
			case DNIPackage.ENTITY_ADDRESS: return createEntityAddress();
			case DNIPackage.GENERIC_WORKLOAD: return createGenericWorkload();
			case DNIPackage.BRANCH_ACTION: return createBranchAction();
			case DNIPackage.LOOP_ACTION: return createLoopAction();
			case DNIPackage.SEQUENCE_ACTION: return createSequenceAction();
			case DNIPackage.START_ACTION: return createStartAction();
			case DNIPackage.STOP_ACTION: return createStopAction();
			case DNIPackage.TRANSMIT_ACTION: return createTransmitAction();
			case DNIPackage.WAIT_ACTION: return createWaitAction();
			case DNIPackage.PERFORMANCE_LINK: return createPerformanceLink();
			case DNIPackage.PERFORMANCE_NETWORK_INTERFACE: return createPerformanceNetworkInterface();
			case DNIPackage.SDN_FLOW_RULE: return createSdnFlowRule();
			case DNIPackage.SDN_CONTROLLER: return createSdnController();
			case DNIPackage.SDN_CONTROLLER_APPLICATION: return createSdnControllerApplication();
			case DNIPackage.COMMON: return createCommon();
			case DNIPackage.SDN: return createSDN();
			case DNIPackage.INTERMEDIATE_PERFORMANCE: return createIntermediatePerformance();
			case DNIPackage.END_PERFORMANCE: return createEndPerformance();
			case DNIPackage.PERFORMANCE_SDN_NODE: return createPerformanceSdnNode();
			case DNIPackage.SPEED_UNIT: return createSpeedUnit();
			case DNIPackage.DATA_UNIT: return createDataUnit();
			case DNIPackage.TIME_UNIT: return createTimeUnit();
			case DNIPackage.CONSTANT_DOUBLE_VARIABLE: return createConstantDoubleVariable();
			case DNIPackage.CONSTANT_LONG_VARIABLE: return createConstantLongVariable();
			case DNIPackage.RANDOM_VARIABLE: return createRandomVariable();
			case DNIPackage.FLOAT_COORDINATE: return createFloatCoordinate();
			case DNIPackage.DISCRETE_FUNCTION: return createDiscreteFunction();
			case DNIPackage.EXPONENTIAL_FUNCTION: return createExponentialFunction();
			case DNIPackage.ENTITY_TYPES: return createEntityTypes();
			case DNIPackage.NODE_TYPE: return createNodeType();
			case DNIPackage.END_PERFORMANCE_TYPE: return createEndPerformanceType();
			case DNIPackage.INTERMEDIATE_PERFORMANCE_TYPE: return createIntermediatePerformanceType();
			case DNIPackage.SDN_NODE_PERFORMANCE_TYPE: return createSdnNodePerformanceType();
			case DNIPackage.NETWORK_INTERFACE_TYPE: return createNetworkInterfaceType();
			case DNIPackage.NETWORK_INTERFACE_PERFORMANCE_TYPE: return createNetworkInterfacePerformanceType();
			case DNIPackage.LINK_TYPE: return createLinkType();
			case DNIPackage.LINK_PERFORMANCE_TYPE: return createLinkPerformanceType();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case DNIPackage.UNIT_PREFIX:
				return createUnitPrefixFromString(eDataType, initialValue);
			case DNIPackage.SPEED:
				return createSpeedFromString(eDataType, initialValue);
			case DNIPackage.TIME:
				return createTimeFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case DNIPackage.UNIT_PREFIX:
				return convertUnitPrefixToString(eDataType, instanceValue);
			case DNIPackage.SPEED:
				return convertSpeedToString(eDataType, instanceValue);
			case DNIPackage.TIME:
				return convertTimeToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInfrastructure createNetworkInfrastructure() {
		NetworkInfrastructureImpl networkInfrastructure = new NetworkInfrastructureImpl();
		return networkInfrastructure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkStructure createNetworkStructure() {
		NetworkStructureImpl networkStructure = new NetworkStructureImpl();
		return networkStructure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Node createNode() {
		NodeImpl node = new NodeImpl();
		return node;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public End createEnd() {
		EndImpl end = new EndImpl();
		return end;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Intermediate createIntermediate() {
		IntermediateImpl intermediate = new IntermediateImpl();
		return intermediate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Link createLink() {
		LinkImpl link = new LinkImpl();
		return link;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInterface createNetworkInterface() {
		NetworkInterfaceImpl networkInterface = new NetworkInterfaceImpl();
		return networkInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkTraffic createNetworkTraffic() {
		NetworkTrafficImpl networkTraffic = new NetworkTrafficImpl();
		return networkTraffic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Flow createFlow() {
		FlowImpl flow = new FlowImpl();
		return flow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdnControlFlow createSdnControlFlow() {
		SdnControlFlowImpl sdnControlFlow = new SdnControlFlowImpl();
		return sdnControlFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericFlowTraffic createGenericFlowTraffic() {
		GenericFlowTrafficImpl genericFlowTraffic = new GenericFlowTrafficImpl();
		return genericFlowTraffic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CommunicatingApplication createCommunicatingApplication() {
		CommunicatingApplicationImpl communicatingApplication = new CommunicatingApplicationImpl();
		return communicatingApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TrafficSource createTrafficSource() {
		TrafficSourceImpl trafficSource = new TrafficSourceImpl();
		return trafficSource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkConfiguration createNetworkConfiguration() {
		NetworkConfigurationImpl networkConfiguration = new NetworkConfigurationImpl();
		return networkConfiguration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolsRepository createProtocolsRepository() {
		ProtocolsRepositoryImpl protocolsRepository = new ProtocolsRepositoryImpl();
		return protocolsRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolStack createProtocolStack() {
		ProtocolStackImpl protocolStack = new ProtocolStackImpl();
		return protocolStack;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolLayer createProtocolLayer() {
		ProtocolLayerImpl protocolLayer = new ProtocolLayerImpl();
		return protocolLayer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkProtocol createNetworkProtocol() {
		NetworkProtocolImpl networkProtocol = new NetworkProtocolImpl();
		return networkProtocol;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoutesRepository createRoutesRepository() {
		RoutesRepositoryImpl routesRepository = new RoutesRepositoryImpl();
		return routesRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Direction createDirection() {
		DirectionImpl direction = new DirectionImpl();
		return direction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FlowRoute createFlowRoute() {
		FlowRouteImpl flowRoute = new FlowRouteImpl();
		return flowRoute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Route createRoute() {
		RouteImpl route = new RouteImpl();
		return route;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Hop createHop() {
		HopImpl hop = new HopImpl();
		return hop;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EntityAddress createEntityAddress() {
		EntityAddressImpl entityAddress = new EntityAddressImpl();
		return entityAddress;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericWorkload createGenericWorkload() {
		GenericWorkloadImpl genericWorkload = new GenericWorkloadImpl();
		return genericWorkload;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BranchAction createBranchAction() {
		BranchActionImpl branchAction = new BranchActionImpl();
		return branchAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopAction createLoopAction() {
		LoopActionImpl loopAction = new LoopActionImpl();
		return loopAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SequenceAction createSequenceAction() {
		SequenceActionImpl sequenceAction = new SequenceActionImpl();
		return sequenceAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StartAction createStartAction() {
		StartActionImpl startAction = new StartActionImpl();
		return startAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StopAction createStopAction() {
		StopActionImpl stopAction = new StopActionImpl();
		return stopAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TransmitAction createTransmitAction() {
		TransmitActionImpl transmitAction = new TransmitActionImpl();
		return transmitAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WaitAction createWaitAction() {
		WaitActionImpl waitAction = new WaitActionImpl();
		return waitAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceLink createPerformanceLink() {
		PerformanceLinkImpl performanceLink = new PerformanceLinkImpl();
		return performanceLink;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceNetworkInterface createPerformanceNetworkInterface() {
		PerformanceNetworkInterfaceImpl performanceNetworkInterface = new PerformanceNetworkInterfaceImpl();
		return performanceNetworkInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdnFlowRule createSdnFlowRule() {
		SdnFlowRuleImpl sdnFlowRule = new SdnFlowRuleImpl();
		return sdnFlowRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdnController createSdnController() {
		SdnControllerImpl sdnController = new SdnControllerImpl();
		return sdnController;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdnControllerApplication createSdnControllerApplication() {
		SdnControllerApplicationImpl sdnControllerApplication = new SdnControllerApplicationImpl();
		return sdnControllerApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common createCommon() {
		CommonImpl common = new CommonImpl();
		return common;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SDN createSDN() {
		SDNImpl sdn = new SDNImpl();
		return sdn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IntermediatePerformance createIntermediatePerformance() {
		IntermediatePerformanceImpl intermediatePerformance = new IntermediatePerformanceImpl();
		return intermediatePerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EndPerformance createEndPerformance() {
		EndPerformanceImpl endPerformance = new EndPerformanceImpl();
		return endPerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceSdnNode createPerformanceSdnNode() {
		PerformanceSdnNodeImpl performanceSdnNode = new PerformanceSdnNodeImpl();
		return performanceSdnNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SpeedUnit createSpeedUnit() {
		SpeedUnitImpl speedUnit = new SpeedUnitImpl();
		return speedUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataUnit createDataUnit() {
		DataUnitImpl dataUnit = new DataUnitImpl();
		return dataUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeUnit createTimeUnit() {
		TimeUnitImpl timeUnit = new TimeUnitImpl();
		return timeUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConstantDoubleVariable createConstantDoubleVariable() {
		ConstantDoubleVariableImpl constantDoubleVariable = new ConstantDoubleVariableImpl();
		return constantDoubleVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConstantLongVariable createConstantLongVariable() {
		ConstantLongVariableImpl constantLongVariable = new ConstantLongVariableImpl();
		return constantLongVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable createRandomVariable() {
		RandomVariableImpl randomVariable = new RandomVariableImpl();
		return randomVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FloatCoordinate createFloatCoordinate() {
		FloatCoordinateImpl floatCoordinate = new FloatCoordinateImpl();
		return floatCoordinate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DiscreteFunction createDiscreteFunction() {
		DiscreteFunctionImpl discreteFunction = new DiscreteFunctionImpl();
		return discreteFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExponentialFunction createExponentialFunction() {
		ExponentialFunctionImpl exponentialFunction = new ExponentialFunctionImpl();
		return exponentialFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EntityTypes createEntityTypes() {
		EntityTypesImpl entityTypes = new EntityTypesImpl();
		return entityTypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeType createNodeType() {
		NodeTypeImpl nodeType = new NodeTypeImpl();
		return nodeType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EndPerformanceType createEndPerformanceType() {
		EndPerformanceTypeImpl endPerformanceType = new EndPerformanceTypeImpl();
		return endPerformanceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IntermediatePerformanceType createIntermediatePerformanceType() {
		IntermediatePerformanceTypeImpl intermediatePerformanceType = new IntermediatePerformanceTypeImpl();
		return intermediatePerformanceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdnNodePerformanceType createSdnNodePerformanceType() {
		SdnNodePerformanceTypeImpl sdnNodePerformanceType = new SdnNodePerformanceTypeImpl();
		return sdnNodePerformanceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInterfaceType createNetworkInterfaceType() {
		NetworkInterfaceTypeImpl networkInterfaceType = new NetworkInterfaceTypeImpl();
		return networkInterfaceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInterfacePerformanceType createNetworkInterfacePerformanceType() {
		NetworkInterfacePerformanceTypeImpl networkInterfacePerformanceType = new NetworkInterfacePerformanceTypeImpl();
		return networkInterfacePerformanceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkType createLinkType() {
		LinkTypeImpl linkType = new LinkTypeImpl();
		return linkType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkPerformanceType createLinkPerformanceType() {
		LinkPerformanceTypeImpl linkPerformanceType = new LinkPerformanceTypeImpl();
		return linkPerformanceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnitPrefix createUnitPrefixFromString(EDataType eDataType, String initialValue) {
		UnitPrefix result = UnitPrefix.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertUnitPrefixToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Speed createSpeedFromString(EDataType eDataType, String initialValue) {
		Speed result = Speed.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertSpeedToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time createTimeFromString(EDataType eDataType, String initialValue) {
		Time result = Time.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertTimeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIPackage getDNIPackage() {
		return (DNIPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static DNIPackage getPackage() {
		return DNIPackage.eINSTANCE;
	}

} //DNIFactoryImpl
